#!/usr/bin/env python
import time
import string
import httplib, sys
from socket import *
import re
import getopt

print "\n*************************************"
print "*TheHarvester Ver. 1.6             *"
print "*Coded by Christian Martorella      *"
print "*Edge-Security Research             *"
print "*cmartorella@edge-security.com      *"
print "*************************************\n\n"

global word
global w
global result
global resulthost
global nexty
resulthost =[]
result = []

def usage():

 print "Usage: theharvester options \n"
 print "       -d: domain to search or company name"
 print "       -b: data source (google,bing,pgp,linkedin)"
 print "       -s: start in result number X (default 0)"
 print "       -v: verify host name via dns resolution"
 print "       -l: limit the number of results to work with(bing goes from 50 to 50 results,"
 print "            google 100 to 100, and pgp does'nt use this option)"
 print "\nExamples:./theharvester.py -d microsoft.com -l 500 -b google"
 print "         ./theharvester.py -d microsoft.com -b pgp"
 print "         ./theharvester.py -d microsoft -l 200 -b linkedin\n"


def run(w, i, eng):
	nexty="0"
	if eng == "bing":
		h = httplib.HTTP('www.bing.com')
		h.putrequest('GET', "/search?q=%40" + w + "&go=&count=50&FORM=QBHL&qs=n&first="+ str(i))
		h.putheader('Host', 'www.bing.com')
		h.putheader('Cookie: mkt=en-US;ui=en-US;SRCHHPGUSR=NEWWND=0&ADLT=DEMOTE&NRSLT=50')
		h.putheader('Accept-Language: en-us,en')
	if eng == "linkedin":
		h = httplib.HTTP('www.google.com')
		h.putrequest('GET', "/search?num=100&start=" + str(i) + "&hl=en&meta=&q=site%3Alinkedin.com%20" + w)
		h.putheader('Host', 'www.google.com')
	elif eng == "google":
		h = httplib.HTTP('www.google.com')
		h.putrequest('GET', "/search?num=100&start=" + str(i) + "&hl=en&meta=&q=%40\"" + w + "\"")
		h.putheader('Host', 'www.google.com')
	elif eng == "pgp":
		h = httplib.HTTP('pgp.rediris.es:11371')
		h.putrequest('GET', "/pks/lookup?search=" + w + "&op=index")
		h.putheader('Host', 'pgp.rediris')
	h.putheader('User-agent', '(Mozilla/5.0 (Windows; U; Windows NT 6.0;en-US; rv:1.9.2) Gecko/20100115 Firefox/3.6')	
	h.endheaders()
	returncode, returnmsg, headers = h.getreply()
	data = h.getfile().read()
	if eng == "bing":
		renext = re.compile('>Next<')
		nextres=renext.findall(data)
		if nextres !=[]:
			nexty="1"
		else:
			nexty="0"
 		data = string.replace(data, '<strong>', '')
 		data = string.replace(data, '</strong>', '')
		for e in ('>', ':', '=', '<', '/', '\\', ';','&'):
			data = string.replace(data, e, ' ')
	elif eng == "google":
		renext = re.compile('>Next<')
		nextres=renext.findall(data)
		if nextres !=[]:
			nexty="1"
		else:
			nexty="0"
		data = re.sub('<b>', '', data)
		data = re.sub('<em>', '', data)
		for e in ('>', ':', '=', '<', '/', '\\', ';','3A'):
			data = string.replace(data, e, ' ')
	elif eng == "linkedin":
		renext = re.compile('>Next<')
		nextres=renext.findall(data)
		if nextres !=[]:
			nexty="1"
		else:
			nexty="0"
 		
		#re1 = re.compile('class=l>[a-zA-Z ,._-]* - LinkedIn</a>')
		re1 = re.compile('>[a-zA-Z ,._-]* - Directory | LinkedIn</a>')
		res = re1.findall(data)
		resul = []
		for x in res:
				y = string.replace(x, ' | LinkedIn</a>', '')
				y = string.replace(x, '- Directory', '')
				y = string.replace(y, '>', '')
				y = string.replace(y, '</a>', '')
				resul.append(y)
		return resul,nexty
	else:
		data = string.replace(data, '&lt;', ' ')
		data = string.replace(data, '&gt;', ' ')
	r1 = re.compile('[a-zA-Z0-9.-_]*' + '@' + '[a-zA-Z0-9.-]*' + w + ' ')
	r3 = re.compile('[a-zA-Z0-9.-_]*\.'+w)

	res3=r3.findall(data)
	res = r1.findall(data)
	return res,nexty,res3

def test(argv):
	global limit
	limit = 100
	start = 0
	cant = 0
	verify = 0
	if len(sys.argv) < 4:
		usage()
		sys.exit()
	try :
	       opts, args = getopt.getopt(argv, "l:d:b:s:v")
	except getopt.GetoptError:
  	     	usage()
		sys.exit()
	for opt, arg in opts :
		if opt == '-l' :
			limit = int(arg)
		elif opt == '-d':
			word = arg
		elif opt == '-s':
			cant=int(arg)
		elif opt == '-v':
			verify= '1'
		elif opt == '-b':
			global engine
			engine = arg
			if engine not in ("bing", "google", "linkedin", "pgp", "all"):
				usage()
				print "Invalid search engine, try with: bing, google, linkedin, pgp"
				sys.exit()

	print "Searching for " + word + " in " + engine + " :"
	print "======================================\n"
	
	if engine == "linkedin":
		word = word.replace(' ', '%20')

	if engine == "pgp":	
		res,nexty = run(word, 0, engine)
		if res == "":
			print "0 account found"
		else:
			for x in res:
				print x
			sys.exit()
	print "Limit: ", limit
	while cant < limit:
		print "Searching results: " + str(cant) + "\r"
		res,nexty,host = run(word, cant, engine)
		for x in res:
	                if result.count(x) == 0:
               		        result.append(x)
		for x in host:
				if resulthost.count(x) == 0:
					resulthost.append(x)	
		if engine == 'google':
			if nexty == "1":
				cant += 100
			else:
				pass
		elif engine == 'bing':
			cant += 50
		elif engine == 'linkedin':
			cant += 100

	print "\nAccounts found:"
	print "====================\n"
	t = 0
	for x in result:
		x = re.sub('<li class="first">', '', x)
		x = re.sub('</li>', '', x)
		print x
		t += 1
	print "====================\n"
	print "Total results: ", t
	
	print "\nHosts found:"	
	print "====================\n"
	for x in resulthost:
		host= x.replace('3A','')
		if verify == '1':
			try:
				g=gethostbyname(host)
				print host + " ===> " + g
			except:
				pass
		else:
			print host

if __name__ == "__main__":
        try: test(sys.argv[1:])
	except KeyboardInterrupt:
		print "Search interrupted by user.."
	except:
		sys.exit()

